from __future__ import generators
import plus
import Arenas
import random
import Hazards
import math


class InsaneArena(Arenas.SuperArena):
    "Your mind is weak"
    name = "Insanity Arena"
    preview = "insanity/insane.bmp"
    game_types = ['DEATHMATCH', 'BATTLE ROYAL', 'TEAM MATCH']
    extent = (-30, 30, 30, -30)

    def __init__(self):
        Arenas.SuperArena.__init__(self, "Arenas/insanity/insane.gmf")
        plus.setBackColor(0,0,0)
        degrad = 0.01745
        self.AddStaticCamera("F2 Please", (0, 8, 10), (30*degrad,math.pi), 84*degrad)
	self.AddWatchCamera("F2 Please", (0, 8, 0), (6, 18, 30*degrad, 10*degrad))
        self.players = ()
        self.AddXtra("Arena", "Arenas/box/boxarena.gmf", "metal")
        self.ArenaIterator = iter(["Arenas/bridge/bridge.gmf", "Arenas/parkinglot/parkinglot.gmf","Arenas/skull/skull.gmf","Arenas/electric/electric.gmf","Arenas/box/boxarena.gmf"])
        self.timer = 0
        
   
    
    def Activate(self, on):
        if on: self.players = plus.getPlayers()
        
        Arenas.SuperArena.Activate(self, on)
        
    def Tick(self):
    	self.timer += 1
    	if self.timer == 40:
             for each in self.players:
                 plus.force(each, 0, 1000 * plus.getWeight(each), 0)
    	if self.timer == 44:
             try: 
                Arena = self.ArenaIterator.next()
                self.RemoveXtra("Arena")
                self.AddXtra("Arena", Arena, "metal")
             except StopIteration:
                self.ArenaIterator = iter(["Arenas/bridge/bridge.gmf", "Arenas/parkinglot/parkinglot.gmf","Arenas/skull/skull.gmf","Arenas/electric/electric.gmf","Arenas/box/boxarena.gmf"])
                Arena = self.ArenaIterator.next() 
                self.RemoveXtra("Arena")
                self.AddXtra("Arena", Arena, "metal")
             self.timer = 0

            
        return Arenas.SuperArena.Tick(self)


Arenas.register(InsaneArena)
